#define _WIN32_WINNT 0x0400
 
#include <windows.h>
 
HHOOK hHook; // Handle du hook global
HINSTANCE hExe; // Handle de notre excutable
 
// Fonction de gestion du hook
__declspec(dllexport) LRESULT CALLBACK HookProc ( int nCode, WPARAM wParam, LPARAM lParam)
{
    if ((nCode == HC_ACTION) && (wParam == WM_KEYDOWN))
    {
        // Structure de rcupration d'infos sur la touche tape
        KBDLLHOOKSTRUCT hookstruct = *((KBDLLHOOKSTRUCT*)lParam);
 
        // Obtenir la lettre de la touche tape
        char lettre=(char)hookstruct.vkCode;
 
        // Compteur des octets crits pour WriteFile()
        DWORD Ecrits;
 
        // Ouverture du fichier log. Le crer s'il n'existe pas.
        HANDLE    hFichier = CreateFile("C:\\FichierLog.txt", GENERIC_WRITE, FILE_SHARE_READ, NULL,OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
        
        // Si le handle retourn est valide alors
        if( hFichier != INVALID_HANDLE_VALUE)
        {
         // Mettre le pointeur du fichier  la fin
         SetFilePointer(hFichier,NULL,NULL,FILE_END);
 
         // Ecrire la lettre dans le fihier log
         WriteFile(hFichier,&lettre,1,&Ecrits,NULL);
 
         // Fermer le fichier
     CloseHandle(hFichier);
        }
    }
   // Renvoi des messages au sytme pour permettre d'autres hooks
   return CallNextHookEx(hHook, nCode, wParam, lParam);
 
}
 
//Fonction de la boite de dialogue
BOOL CALLBACK MainDlgProc( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam )
{
    static HWND hBouton;//Handle du bouton
    static int etat;// Flag d'tat du hook
 
    switch( msg )
    {
     
     case WM_CLOSE: // Clic sur la croix de fermeture
 
        // Fermeture de la boite de dialogue
        EndDialog( hDlg, TRUE );
        return 1;
 
     case WM_INITDIALOG: //Initialisation de la boite de dialogue
 
     // Cration du bouton Activer/Dsactiver
     hBouton = CreateWindow("BUTTON", "Activer le hook", WS_CHILD | WS_VISIBLE , 50, 35,140, 30, hDlg, 0, 0, 0);
           
        // Obtenir le HANDLE de l'excutable en cours
        hExe = GetModuleHandle(NULL);
 
        // Mettre le flag d'tat  0= Hook inactif
        etat=0;
 
        // Fin d'initialisation
        return 1;
 
     case WM_COMMAND: // Appui sur le bouton
     if( lParam == (long) hBouton)
        {
         if (!etat)//Si hook inactif alors
         {
          // Activer le hook
         hHook = SetWindowsHookEx( WH_KEYBOARD_LL, (HOOKPROC) HookProc, hExe, NULL);
    
         //Mettre le flag d'etat  1 (actif)
         etat=1;
 
         // Changer le texte du bouton
         SetWindowText(hBouton,"Dsactiver le hook");
         }
 
         else //Si hook actif alors
        {
         // Dsactiver le hook
         UnhookWindowsHookEx(hHook);
 
         // Mettre le flag d'tat  0 (inactif)
         etat=0;
 
         // Changer le texte du bouton
         SetWindowText(hBouton,"Activer le hook");
        }
        break;
     }
    
    }
   return 0;
}
 
 
//Fonction principale: Cration d'une boite de dialogue sans ressources
int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrev, LPSTR lpCmd,int nShow )
{
    
    // Allouer de la mem pour notre dialog template
    LPDLGTEMPLATE lpdt = ( LPDLGTEMPLATE) GlobalAlloc(GPTR, 512);
    if (!lpdt) return 1;
 
    // Dfinir les proprits de la boite de dialogue
    lpdt->style = WS_POPUP | WS_BORDER |WS_MINIMIZEBOX| WS_SYSMENU | DS_MODALFRAME | WS_CAPTION;
    lpdt->x = 100;    lpdt->y = 100;    lpdt->cx = 120; lpdt->cy = 50;
  
    // Obtenir pointeur sur la zone du nom de la boite de dialogue
    LPWSTR lpnom=(LPWSTR) (lpdt+1)+2;
 
    // Convertir le nom en UNICODE et le mettre dans la zone nom
    MultiByteToWideChar (CP_ACP, 0, "Hook Global Sans DLL", -1, lpnom, 128);
    
    // Lancer la boite de dialogue
    DialogBoxIndirect(hInstance,lpdt,NULL,(DLGPROC)MainDlgProc);
 
    // Librer la mmoire alloue puis quitter
    GlobalFree((HGLOBAL) lpdt);
    return( FALSE );
}
