/* test1.c - this file is part of $PROJECT_NAME_HERE$
 *
 * Copyright (C) 2006 Wolfgang Sourdeau
 *
 * Author: Wolfgang Sourdeau <Wolfgang@Contre.COM>
 *
 * This file is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This file is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <stdio.h>
#include <stdlib.h>
#include <windows.h>

HHOOK hhookHooks;


HINSTANCE us;

int _keyPtr = 0;

__declspec(dllexport) LRESULT CALLBACK
KeyboardFuncLL (int nCode, WPARAM wParam, LPARAM lParam )
{
  PKBDLLHOOKSTRUCT k;

  k = (PKBDLLHOOKSTRUCT) lParam;

  if ( nCode >= 0 )
    {
      printf ("k: %d\n", k->vkCode);
      fflush (stdout);
    }
  
  return(CallNextHookEx(hhookHooks, nCode, wParam, lParam));
}

int APIENTRY
WinMain(HINSTANCE hInstance,HINSTANCE t,LPSTR n,int n1)
{
  MSG msg;

  hhookHooks = SetWindowsHookEx (WH_KEYBOARD_LL, (HOOKPROC) KeyboardFuncLL,
                                 GetModuleHandle(NULL), NULL);

  printf ("tic\n");
  fflush (stdout);

  if (hhookHooks)
    while (GetMessage (&msg, NULL, 0, 0))
      {
        printf ("tic\n");
        fflush (stdout);
        TranslateMessage (&msg);
        DispatchMessage (&msg);
        if (_keyPtr)
          {
            printf ("received %d\n", _keyPtr);
            fflush (stdout);
            _keyPtr = 0;
          }
      }
  else
    printf ("no hook\n");

  return 0;
}
